    //************************************//
    //    osc.error.js                    //
    //                                    //
    // Example error processing of        //
    // generic OSC API error condition    //
    //                                    //
    // dev@osc                            //
    //                                    //
    // Ver 1.x                            //
    // (c) OSC 2024 - 2025                //
    //************************************//

/*************************************************/
//    Function used to check the error message   */
//    in case server returns a Non 2XX status    */
/*************************************************/

function set_server_error( httpResponse ) {
var msgBody = httpResponse.response;
var errMsg = "No extra information";

    // Make sure this is a JSON format error

    try {
    var data = JSON.parse( msgBody );

        // All good - Set the error message

        if( "message" in data )
        {
            if( data.message.responseCode != undefined )
            {
                errMsg = data.message.responseCode;
                if( data.message.errorDetail != undefined )
                    errMsg += " " + data.message.errorDetail;
            }
            else
                errMsg = data.message;
        }
        else if( data.response != undefined )
        {
            if( data.response.detail != undefined )
                errMsg = data.response.detail ;
        }
    }
    catch( errors )
    {

        // Not JSON so get the data

        errMsg = msgBody;
        if( !errMsg )
            errMsg = httpResponse.statusText;
    }
    return errMsg;
}

    //************************************************
    //   Process a response to an OSC API call
    //************************************************

    //    Get the returned data and check for success/failure

    if ( Math.floor( this.status/100 ) != 2 ) 
    {
    var errMsg = process_error( this.response );

        alert( errMsg );
    }

